-- Printing LTS to CSV --

----------------------------------------------------------------------

-- | Prints the LTS graph using the CSV format.
printCSV :: [Node] -> String -> String
printCSV [] _ = ""
printCSV [(number,state,trans)] fieldSep
  = (dumpCSVNode (number,state,[]) fieldSep) ++ fieldSep ++ "["
  ++ (dumpCSVTrans trans) ++ "]"
printCSV ((number,state,trans):nodes) fieldSep
  = (dumpCSVNode (number,state,[]) fieldSep) ++ fieldSep ++ "["
  ++ (dumpCSVTrans trans) ++ "]\n" ++ (printCSV nodes fieldSep)

----------------------------------------------------------------------

-- | Converts a list of arcs into single string value.
dumpCSVTrans :: [(TTransition, Int)] -> String
dumpCSVTrans [] = ""
dumpCSVTrans [(transition,number)]
  = "(" ++ (show transition) ++ "," ++ (show number) ++ ")"
dumpCSVTrans ((transition,number):transitions)
  = "(" ++ (show transition) ++ "," ++ (show number) ++ ")," ++ (dumpCSVTrans transitions)

----------------------------------------------------------------------

-- | Prints the node using the CSV format.
dumpCSVNode :: Node -> String -> String
dumpCSVNode (number,state,_) fieldSep
  = (show number) ++ fieldSep ++ (dumpCSVState 1 state fieldSep)

----------------------------------------------------------------------

-- | Prints the state using the CSV format.
dumpCSVState :: Int -> State -> String -> String
dumpCSVState number state fieldSep
  | number == modelSize = (show (agents !! (number - 1))) ++ fieldSep
  ++ (show (takeam number state)) ++ fieldSep
  ++ (show (takepc number state)) ++ fieldSep
  ++ (show (toList (takeci number state))) ++ fieldSep
  ++ (takepvString number state)
  | otherwise = (show (agents !! (number - 1))) ++ fieldSep
  ++ (show (takeam number state)) ++ fieldSep
  ++ (show (takepc number state)) ++ fieldSep
  ++ (show (toList (takeci number state))) ++ fieldSep
  ++ (takepvString number state) ++ fieldSep
  ++ (dumpCSVState (number + 1) state fieldSep)

----------------------------------------------------------------------
