----------------------------------------------------------------------

-- | Prints the LTS graph using the Aldebaran format.
printALD :: [Node] -> String
printALD ltsGraph = "des (0," ++ show (countTransitions(0, ltsGraph)) 
                  ++ "," ++ show (length ltsGraph) ++ ")\n" 
                  ++ dumpALDtrans ltsGraph 

----------------------------------------------------------------------

-- | Returns the number of arcs of the LTS graph.
countTransitions :: (Int,[Node]) -> Int
countTransitions (cnt, []) = cnt
countTransitions (cnt, (number,state,arcs):nodes) 
  = countTransitions(cnt + countT(arcs), nodes)

----------------------------------------------------------------------

-- | Recursive function for counting arcs.
countT :: [(TTransition,Int)] -> Int
countT [] = 0
countT (_:arcs) = 1 + countT arcs

----------------------------------------------------------------------

-- | Prints the LTS graph arcs using the Aldebaran format.
dumpALDTrans :: [Node] -> String
dumpALDTrans [] = []
dumpALDTrans (node:nodes) = dumpSingleTransALD node ++ dumpALDTrans nodes

----------------------------------------------------------------------

-- | Prints list of arcs for the given node (Aldebaran format).
dumpSingleTransALD :: Node -> String
dumpSingleTransALD (number,_,arcs) = dumpTRALD (number,arcs)

----------------------------------------------------------------------

-- | Recursive function for printing a list of arcs for the given node.
dumpTRALD :: (Int,[(TTransition,Int)]) -> String
dumpTRALD (_,[]) = []
dumpTRALD (source,(transition,destination):arcs) 
  = "(" ++ (show source) ++ "," ++ (show transition) ++ "," 
  ++ (show destination) ++ ")\n" ++ dumpTRALD (source,arcs)

----------------------------------------------------------------------
